
// little node thing that pretends to be Little Sky

var	dgram = require ("dgram");
var	os = require ("os");

var	address = getIPAddress ();

var	socket = dgram.createSocket ("udp4");

socket.bind
(
	50007,
	"0.0.0.0",
	function (inError)
	{
		if (inError)
		{
			console.error ("error binding socket");
			console.error (inError);
		}
		
		littleSky ();
	}
);

function
littleSky ()
{
	socket.on
	(
		"message",
		function (inMessage, inRemoteInfo)
		{
			var	messageString = inMessage.toString ();
			
			if (messageString.charAt (0) == "!")
			{
				console.log ("little sky message received");
				console.log (messageString);
				
				// strip the opening ! and trailing ;
				messageString = messageString.slice (1, messageString.length - 1);
				
				var	messageElements = messageString.split (",");
				
				var	messageOpcode = messageElements.splice (0, 1) [0];
				messageOpcode = messageOpcode.toLowerCase ();
				
				// find a handler!
				// which doesn't work dynamically, for some reason - WTF?!?
				
				var	handlerName = "ls_message_" + messageOpcode;
				
				if (handlerName == "ls_message_discover")
				{
					ls_message_discover (inRemoteInfo, messageElements);
				}
			}
			else
			{
				console.error ("non-LS message received");
				console.error (messageString);
			}
		}
	);
}

function
ls_message_discover (inRemoteInfo, inParameters)
{
	var	message = "!OK,discover," + address + ",Fake Little Sky,Base,0,0,0;";
	var	messageBuffer = new Buffer (message);

	socket.send
	(
		messageBuffer,
		0,
		messageBuffer.length,
		inRemoteInfo.port,
		inRemoteInfo.address,
		function (inError)
		{
			if (inError)
			{
				console.error (inError);
			}
		}
	);

}

function
getIPAddress ()
{
	var	address = null;
	
	var	interfaces = os.networkInterfaces ();
	
	for (var name in interfaces)
	{
		var	addresses = interfaces [name];
		
		for (var i = 0; i < addresses.length; i++)
		{
			var	address = addresses [i];
			
			if (! address.internal)
			{
				if (address.family.toLowerCase () == "ipv4")
				{
					// should probably check for dups here, but how would we?
					address = address.address;

					break;
				}
			}
		}
		
		if (address && address.length)
		{
			break;
		}
	}

	if (address == null || address.length == 0)
	{
		address = "127.0.0.1";
	}

	return address;
}
