
// little node thing that pretends to be Little Sky

var	dgram = require ("dgram");
var	os = require ("os");

var	address = getIPAddress ();

var	socket = dgram.createSocket ("udp4");

socket.bind
(
	0,
	"0.0.0.0",
	function (inError)
	{
		if (inError)
		{
			console.error ("error binding socket");
			console.error (inError);
		}
		littleSky ();
		setNickname ("MWC Little Sky");
	}
);

function
littleSky ()
{
	socket.on
	(
		"message",
		function (inMessage, inRemoteInfo)
		{
			var	messageString = inMessage.toString ();
			
			if (messageString.charAt (0) == "!")
			{
				console.log ("little sky message received");
				console.log (messageString);
			}
			else
			{
				console.error ("non-LS message received");
				console.error (messageString);
			}
		}
	);
}

function
setNickname (inNickname)
{
	var	message = "!set_nick," + inNickname + ";";
	console.log ("sending " + message);
	
	var	messageBuffer = new Buffer (message);

	socket.send
	(
		messageBuffer,
		0,
		messageBuffer.length,
		50007,
		"192.168.0.100",
		function (inError)
		{
			if (inError)
			{
				console.error (inError);
			}
		}
	);

}

function
getIPAddress ()
{
	var	address = null;
	
	var	interfaces = os.networkInterfaces ();
	
	for (var name in interfaces)
	{
		var	addresses = interfaces [name];
		
		for (var i = 0; i < addresses.length; i++)
		{
			var	address = addresses [i];
			
			if (! address.internal)
			{
				if (address.family.toLowerCase () == "ipv4")
				{
					// should probably check for dups here, but how would we?
					address = address.address;

					break;
				}
			}
		}
		
		if (address && address.length)
		{
			break;
		}
	}

	if (address == null || address.length == 0)
	{
		address = "127.0.0.1";
	}

	return address;
}
